﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.DataGrid;

namespace SL_DataGrid_EditableUnboundColumn
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<MyDataClass> dataList = new ObservableCollection<MyDataClass>();

        public MainPage()
        {
            InitializeComponent();
            this.Loaded += MainPage_Loaded;

        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            dataList.Add(new MyDataClass() { Name = "John", Age = 25, Department = "Computers" });
            dataList.Add(new MyDataClass() { Name = "Dave", Age = 35, Department = "Biology" });
            dataList.Add(new MyDataClass() { Name = "Paul", Age = 29, Department = "Physics" });
            dataList.Add(new MyDataClass() { Name = "Tim", Age = 30, Department = "Computers" });
            dataList.Add(new MyDataClass() { Name = "Yana", Age = 32, Department = "Chemistry" });
            dataList.Add(new MyDataClass() { Name = "David", Age = 28, Department = "Biology" });

            c1DataGrid1.ItemsSource = dataList;

            Binding tempBinding = new System.Windows.Data.Binding()
                {
                    Path = new PropertyPath("[Temp]"),
                    Mode = System.Windows.Data.BindingMode.OneTime,
                };

            (c1DataGrid1.Columns[3] as C1.Silverlight.DataGrid.DataGridTextColumn).Binding = tempBinding;
            (c1DataGrid1.Columns[3] as C1.Silverlight.DataGrid.DataGridTextColumn).Tag = "tempBinding";

            c1DataGrid1.BeginningEdit += c1DataGrid1_BeginningEdit;
            c1DataGrid1.BeganEdit += c1DataGrid1_BeganEdit;

            c1DataGrid1.CommittingEdit += new EventHandler<DataGridEndingEditEventArgs>(c1DataGrid1_CommittingEdit);
            c1DataGrid1.CommittedEdit += new EventHandler<DataGridCellEventArgs>(c1DataGrid1_CommittedEdit);

        }

        string unBoundCellValue;
        bool unboundFlagUpdateValue;
        
        void c1DataGrid1_BeganEdit(object sender, DataGridBeganEditEventArgs e)
        {
            if (unBoundCellValue != "")
                ((C1.Silverlight.C1TextBoxBase)(e.EditingElement)).C1Text = unBoundCellValue;
        }

        void c1DataGrid1_BeginningEdit(object sender, DataGridBeginningEditEventArgs e)
        {
            if (e.Column.Tag != null)
                if (e.Row.DataItem != null)                
                    unBoundCellValue = (c1DataGrid1[e.Row, e.Column].Presenter.Content as TextBlock).Text;                  
        }       

        void c1DataGrid1_CommittingEdit(object sender, DataGridEndingEditEventArgs e)
        {
            if (e.Column.Tag != null)
                if (e.Row.DataItem != null)
                {
                    unboundFlagUpdateValue = true;
                    unBoundCellValue = ((C1.Silverlight.C1TextBoxBase)(e.EditingElement)).C1Text;
                }
        }

        void c1DataGrid1_CommittedEdit(object sender, DataGridCellEventArgs e)
        {
            if (unboundFlagUpdateValue)
                (e.Cell.Presenter.Content as TextBlock).Text = unBoundCellValue;

            unboundFlagUpdateValue = false;
        }

    }

    public class MyDataClass
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public string Department { get; set; }
    }
}
